technique T0
{
    pass P0
    {
		// Constants Expected:
		// c92-c95: CV_VIEWPROJ
		// c1: minimum alpha, maximum alpha, slope, 0
    
		// Disable specular
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// First stage
		ColorOp[0]   = Disable;
        AlphaOp[0]   = Disable;
        
        // Second stage
        // Only one color being used
        ColorOp[1]   = Disable;
        AlphaOp[1]   = Disable;
	
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            stream 1;
            D3DCOLOR v1;	// Diffuse color
        }
		asm
		{
			vs.1.1						// Vertex shader version 1.1
			m4x4 r0, v0, c92			// Transform position, Apply view+proj
			
			mov r6, v1					// copy the diffuse color
			
			mov r2.w, c1.y				// copy the max alpha
			mad r3.w, r0.w, c1.z, r2.w	// calculate the alpha fog using slope-intercept line equation
			max r4.w, r3.w, c1.x		// ensure it doesn't fall below a min alpha
			min r5.w, r4.w, r2.w		// ensure it doesn't fall above a max alpha
			
			mul r6.w, r5.w, v1.w		// multiply fog alpha with vertex alpha (gives a range between [0.0,vertex alpha])
			
			mov oD0, r6					// move the new fogged color into Diffuse Color output
			mov oPos, r0				// move vertex to the output vertex register
		};		
		
   }
    
}

