texture tMap;
texture tBuf;

technique T0
{
    pass P0
    {	
		// Disable specular
		SpecularEnable = False;
			
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= True;
		
		// Set alpha blending mode
		AlphaBlendEnable = False;
		
		// Set texture address mode and min mag filters
		AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MipFilter[0]	= Linear;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MipFilter[1]	= Linear;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
            stream 2;
            short v8[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			m4x4	oPos, v0, c92
			slt		oFog.x, v0, v0
			
			// No lighting
		
			// Move the uvs through...
			mul		r0, v7, c91.x
			add		oT0.xyz, r0, c60
			mul		r0, v8, c91.x
			add		oT1.xyz, r0, c61
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1

			mul_x2 r0, t0, t1
        }; 
    }
}