technique T0
{
    pass P0
    {
		SpecularEnable = False;
		
		CullMode		= None;
				
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		AlphaTestEnable = False;
						
		// Set texture address mode and min mag filters
		MipFilter[0]	= Point;
		MinFilter[0]	= Point;
		MagFilter[0]	= Point;
		MipMapLODBias[0]= -1;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v1[4];	// Color with alpha
            float v2[2];	// tex-coordx UV
        }
		asm
		{
			vs.1.1

			// Apply view+proj
			m4x4			r0, v0, c92
			mov				oPos, r0
			
			mov				oFog.x, r0.w

			// Set the Alpha Value
			mov				oD0, v1
			
			// Set the texcoords
			mov				oT0.xy, v2.xy
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1
			
			// Define the textures
			tex t0

			// mov r0, v0		// non-tex
			mul r0, v0, t0
        };   
    }
}
