technique T0
{
    pass P0
    {
		// Set texture address mode and min mag filters
		AddressU[0]		= Wrap;
		AddressV[0]		= Wrap;
		MipFilter[0]	= None;
		MinFilter[0]	= Linear;
		MagFilter[0]	= Linear;
		
		AddressU[1]		= Wrap;
		AddressV[1]		= Wrap;
		MipFilter[1]	= None;
		MinFilter[1]	= Linear;
		MagFilter[1]	= Linear;
		
		AddressU[2]		= Wrap;
		AddressV[2]		= Wrap;
		MipFilter[2]	= None;
		MinFilter[2]	= Linear;
		MagFilter[2]	= Linear;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            D3DCOLOR v3;	// Normal
            stream 1;
            short v7[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			m4x4	r0, v0, c92
			mov		oPos, r0
			mov		oFog.x, r0.w // Take out fog
			
			// Move the uvs through...
			mul		r0, v7, c91.x
			mov		oT0.xyz, r0
			add		oT1.xyz, r0, c61
			add		oT2.xyz, r0, c62	
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0
			tex t1
			tex t2

			mul r0.rgb, t1, t2
			+mul r0.a, t0.a, t1.a
			mul r0.a, r0.a, t2.a			
        };   
    }
}