
technique T0
{
    pass P0
    {
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v7[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			add		r1, v0, c90
			m4x4	r0, r1, c92
			sge		r0.z, r1, r1	// force a z buffer value of 1
			mov		oPos, r0
			slt		oFog.x, v0, v0

			// Move the uvs through...
			add		oT0, v7, c60
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t0

			mov r0, t0
        }; 
    }
}

technique T1
{
    pass P0
    {
		// First stage
        ColorOp[0]   = SelectArg1;
        ColorArg1[0] = Texture;
        ColorArg2[0] = Texture;
        AlphaOp[0]   = SelectArg1;
        AlphaArg1[0] = Texture;
        AlphaArg2[0] = Texture;
        
        // Second stage
        ColorOp[1]	 = Disable;
        AlphaOp[1]   = Disable;
        
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v7[2];	// UV
        }
		asm
		{
			vs.1.1

			// Transform position
			// Apply view+proj
			add		r1, v0, c90
			m4x4	r0, r1, c92
			sge		r0.z, r1, r1	// force a z buffer value of 1
			mov		oPos, r0
			slt		oFog.x, v0, v0

			// Move the uvs through...
			add		oT0, v7, c60
		};		
    }
}