technique T0
{
    pass P0
    {
		SpecularEnable = False;
		
		// Set Z-buffering
		ZEnable			= True;
		ZWriteEnable	= False;
		
		// Set alpha blending mode
		AlphaBlendEnable = True;
		SrcBlend		= SrcAlpha;
		DestBlend		= InvSrcAlpha;
		AlphaTestEnable = True;
						
		// Set texture address mode and min mag filters
		MipFilter[3]	= Point;
		MinFilter[3]	= Point;
		MagFilter[3]	= Point;
		MipMapLODBias[3]= -1;
		
		VertexShader =
        decl
        {
            stream 0;
            float v0[3];	// Position
            float v1;		// Size
            float v2;		// Alpha
        }
		asm
		{
			vs.1.1

			// Put into screen space
			m4x3			r3, v0, c0
			sge				r3.w, v0, v0

			m4x4			r1, r3, c92
			mov				oPos, r1

			mov				oFog.x, r1.w

			// Set the Alpha Value
			mov				oD0.w, v2.x

			// Set the Point Size
			rcp				r1.x, r1.w
			mul				oPts.x, r1.x, v1.x		
			
		};
		
		PixelShader = 
        asm
        {
			// Declare pixel shader version 1.1
			ps.1.1

			// Define textures
			tex t3

			mov r0.rgb, t3
			+mul r0.a, t3, v0
        };   
    }
}
